How to keep Dialog centered on page scroll in EJ2 JavaScript Dialog

21 Aug 20265 minutes to read

By default, when scroll the page/container Dialog also scrolled along with the page/container. When a user expects to display the Dialog in the same position without scrolling achieving this in sample level as like below. Here added ‘e-fixed’ class to Dialog element by using cssClass property and prevent the scrolling.

ej.base.enableRipple(true);

// Initialize Dialog component
var dialog = new ej.popups.Dialog({
    // Enables the header
    header: 'Dialog',
    // Dialog content
    content: document.getElementById("dlgContent"),
    // Disable the Esc key to hide the Dialog
    closeOnEscape: false,
    // The Dialog shows within the target element
    target: document.getElementById("container"),
    // Dialog width
    width: '250px',
    beforeOpen: onBeforeopen
});
// Render initialized Dialog
dialog.appendTo('#dialog');

// Sample level code to prevent Dialog scrolling
document.getElementById('targetButton').onclick = function() {
    dialog.cssClass = 'e-fixed';
}

function onBeforeopen() {
    document.getElementById('dlgContent').style.visibility = 'visible';
}
<!DOCTYPE html><html lang="en"><head>
    <title>Essential JS 2 Dialog with scrollable content</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="TypeScript UI Components">
    <meta name="author" content="Syncfusion">
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-base/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-buttons/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-popups/styles/material.css" rel="stylesheet">
    <link href="styles.css" rel="stylesheet">
    
    
<script src="https://cdn.syncfusion.com/ej2/34.2.2/dist/ej2.min.js" type="text/javascript"></script>
</head>

<body>
    
    <div id="container">
        <div>
            <b>JavaScript:</b><br>
            JavaScript is a high-level, dynamic, untyped, and interpreted programming language. It has been standardized in the ECMAScript
            language specification. Alongside HTML and CSS, it is one of the three essential technologies of World Wide Web
            content production; the majority of websites employ it and it is supported by all modern Web browsers without
            plug-ins. JavaScript is prototype-based with first-class functions, making it a multi-paradigm language, supporting
            object - oriented , imperative, and functional programming styles.
            <br><br><br>
            <b>MVC:</b><br>
            Model–view–controller (MVC) is a software architecture pattern which separates the representation of information from the user's interaction with it. The model consists of application data, business rules, logic, and functions. A view can be any output representation of data, such as a chart or a diagram. Multiple views of the same data are possible, such as a bar chart for management and a tabular view for accountants. The controller mediates input, converting it to commands for the model or view.The central ideas behind MVC are code reusability and in addition to dividing the application into three kinds of components, the MVC design defines the interactions between them.
            A controller can send commands to its associated view to change the view's presentation of the model (e.g., by scrolling through a document). It can also send commands to the model to update the model's state (e.g., editing a document).
            A model notifies its associated views and controllers when there has been a change in its state. This notification allows the views to produce updated output, and the controllers to change the available set of commands. A passive implementation of MVC omits these notifications, because the application does not require them or the software platform does not support them.
            A view requests from the model the information that it needs to generate an output representation to the user.
        </div>
        <div id="dialog"></div>
        <div id="dlgContent" style="visibility: hidden">
            <button class="e-control e-btn" id="targetButton" role="button">Prevent Dialog Scroll</button>
        </div>
    </div>

<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

Position the dialog at center when scrolling in Angular Dialog component

26 Feb 20265 minutes to read

By default, the dialog scrolls along with the page or container. To keep the dialog in a fixed position without scrolling, add the e-fixed class to the dialog element and prevent scrolling as shown in the sample below.

import { NgModule } from '@angular/core'
import { BrowserModule } from '@angular/platform-browser'
import { DialogModule } from '@syncfusion/ej2-angular-popups'




import { Component, ViewChild, OnInit, ElementRef } from '@angular/core';
import { DialogComponent } from '@syncfusion/ej2-angular-popups';
import { EmitType } from '@syncfusion/ej2-base';

@Component({
imports: [
        
		DialogModule
    ],


standalone: true,
    selector: 'app-root',
    template: ` <div #container class='root-container'></div>
            <div>
            <b>JavaScript:</b><br />
            JavaScript is a high-level, dynamic, untyped, and interpreted programming language. It has been standardized in the ECMAScript
            language specification. Alongside HTML and CSS, it is one of the three essential technologies of World Wide Web
            content production; the majority of websites employ it and it is supported by all modern Web browsers without
            plug-ins. JavaScript is prototype-based with first-class functions, making it a multi-paradigm language, supporting
            object - oriented , imperative, and functional programming styles.
            <br /><br /><br />
            <b>MVC:</b><br />
            Model–view–controller (MVC) is a software architecture pattern which separates the representation of information from the user's interaction with it. The model consists of application data, business rules, logic, and functions. A view can be any output representation of data, such as a chart or a diagram. Multiple views of the same data are possible, such as a bar chart for management and a tabular view for accountants. The controller mediates input, converting it to commands for the model or view.The central ideas behind MVC are code reusability and in addition to dividing the application into three kinds of components, the MVC design defines the interactions between them.
            A controller can send commands to its associated view to change the view's presentation of the model (e.g., by scrolling through a document). It can also send commands to the model to update the model's state (e.g., editing a document).
            A model notifies its associated views and controllers when there has been a change in its state. This notification allows the views to produce updated output, and the controllers to change the available set of commands. A passive implementation of MVC omits these notifications, because the application does not require them or the software platform does not support them.
            A view requests from the model the information that it needs to generate an output representation to the user.
        </div>

      <ejs-dialog id='dialog' #ejDialog header='Dialog' showOnInit='true' [target]='targetElement' width='250px' [closeOnEscape]='closeOnEscape'>
      <div style='padding:18px;padding-top:0px;'>
      <button class="e-control e-btn" id="targetButton" role="button" (click)="onPreventScroll($event)">Prevent Dialog Scroll</button>
      </div>
      </ejs-dialog>
        `
})

export class AppComponent implements OnInit {
    @ViewChild('ejDialog') ejDialog: DialogComponent | any;
    // Create element reference for dialog target element.
    @ViewChild('container', { read: ElementRef }) container: ElementRef | any;
    // The Dialog shows within the target element.
    public targetElement?: HTMLElement;

    //To get all element of the dialog component after component get initialized.
    ngOnInit() {
      this.initilaizeTarget();
    }

    // Initialize the Dialog component target element.
    public initilaizeTarget: EmitType<object> = () => {
      this.targetElement = this.container.nativeElement.parentElement;
    }
    // Disable the Esc key option to hide the Dialog
    public closeOnEscape: boolean =false;
    // Add e-fixed class to Dialog element
    public onPreventScroll = (event: any): void => {
        this.ejDialog.cssClass='e-fixed';
    }
    // Dialog content
    public content:string='<button class="e-control e-btn" id="targetButton" role="button">Prevent Dialog Scroll</button>';

}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Syncfusion AI Assistant

How can I help you?

Position the dialog on center of the page on scrolling in Vue Dialog component

5 Jun 202414 minutes to read

By default, when scroll the page/container Dialog also scrolled along with the page/container. When a user expects to display the Dialog in the same position without scrolling achieving this in sample level as like below. Here added e-fixed class to Dialog element and prevent the scrolling.

<template>
    <div>
        <div id="target" class="control-section; position:relative">
            <div>
                <b>JavaScript:</b><br />
                JavaScript is a high-level, dynamic, untyped, and interpreted programming language. It has been standardized
                in the ECMAScript
                language specification. Alongside HTML and CSS, it is one of the three essential technologies of World Wide
                Web
                content production; the majority of websites employ it and it is supported by all modern Web browsers
                without
                plug-ins. JavaScript is prototype-based with first-class functions, making it a multi-paradigm language,
                supporting
                object - oriented , imperative, and functional programming styles.
                <br /><br /><br />
                <b>MVC:</b><br />
                Model–view–controller (MVC) is a software architecture pattern which separates the representation of
                information from the user's interaction with it. The model consists of application data, business rules,
                logic, and functions. A view can be any output representation of data, such as a chart or a diagram.
                Multiple views of the same data are possible, such as a bar chart for management and a tabular view for
                accountants. The controller mediates input, converting it to commands for the model or view.The central
                ideas behind MVC are code reusability and in addition to dividing the application into three kinds of
                components, the MVC design defines the interactions between them.
                A controller can send commands to its associated view to change the view's presentation of the model (e.g.,
                by scrolling through a document). It can also send commands to the model to update the model's state (e.g.,
                editing a document).
                A model notifies its associated views and controllers when there has been a change in its state. This
                notification allows the views to produce updated output, and the controllers to change the available set of
                commands. A passive implementation of MVC omits these notifications, because the application does not
                require them or the software platform does not support them.
                A view requests from the model the information that it needs to generate an output representation to the
                user.
            </div>
            <!-- Render Dialog -->
            <ejs-dialog ref="scrollDialog" :header='header' :target='target' :width='width' :showCloseIcon='true'
                :content='content' :open="dlgOpen" :close="dlgClose">
            </ejs-dialog>
        </div>
    </div>
</template>
<script setup>

import { DialogComponent as EjsDialog } from '@syncfusion/ej2-vue-popups';
import { onMounted, ref } from 'vue';

const scrollDialog = ref(null);

const target = '#target';
const width = '335px';
const header = 'Dialog';
const content = '<button class="e-control e-btn" id="targetButton" role="button" >Prevent Dialog Scroll</button>';

onMounted(() => {
    document.getElementById('targetButton').onclick = () => {
        scrollDialog.value.ej2Instances.cssClass = 'e-fixed';
    }
});
const dlgClose = () => {
    document.getElementById('modalbtn').style.display = '';
};
const dlgOpen = () => {
    document.getElementById('modalbtn').style.display = 'none';
};
</script>
<style>
@import "../node_modules/@syncfusion/ej2-vue-popups/styles/material.css";

#app {
    color: #008cff;
    height: 40px;
    left: 45%;
    position: absolute;
    top: 45%;
    width: 30%;
}

html,
body,
.control-section {
    height: 120%;
    min-height: 200px;
}

body {
    overflow-y: scroll;
}

#loader {
    color: #008cff;
    height: 40px;
    left: 45%;
    position: absolute;
    top: 45%;
    width: 30%;
}

.e-fixed {
    position: fixed;
}
</style>
<template>
    <div>
        <div id="target" class="control-section; position:relative">
            <div>
                <b>JavaScript:</b><br />
                JavaScript is a high-level, dynamic, untyped, and interpreted programming language. It has been standardized
                in the ECMAScript
                language specification. Alongside HTML and CSS, it is one of the three essential technologies of World Wide
                Web
                content production; the majority of websites employ it and it is supported by all modern Web browsers
                without
                plug-ins. JavaScript is prototype-based with first-class functions, making it a multi-paradigm language,
                supporting
                object - oriented , imperative, and functional programming styles.
                <br /><br /><br />
                <b>MVC:</b><br />
                Model–view–controller (MVC) is a software architecture pattern which separates the representation of
                information from the user's interaction with it. The model consists of application data, business rules,
                logic, and functions. A view can be any output representation of data, such as a chart or a diagram.
                Multiple views of the same data are possible, such as a bar chart for management and a tabular view for
                accountants. The controller mediates input, converting it to commands for the model or view.The central
                ideas behind MVC are code reusability and in addition to dividing the application into three kinds of
                components, the MVC design defines the interactions between them.
                A controller can send commands to its associated view to change the view's presentation of the model (e.g.,
                by scrolling through a document). It can also send commands to the model to update the model's state (e.g.,
                editing a document).
                A model notifies its associated views and controllers when there has been a change in its state. This
                notification allows the views to produce updated output, and the controllers to change the available set of
                commands. A passive implementation of MVC omits these notifications, because the application does not
                require them or the software platform does not support them.
                A view requests from the model the information that it needs to generate an output representation to the
                user.
            </div>
            <!-- Render Dialog -->
            <ejs-dialog ref="scrollDialog" :header='header' :target='target' :width='width' :showCloseIcon='true'
                :content='content' :open="dlgOpen" :close="dlgClose">
            </ejs-dialog>
        </div>
    </div>
</template>
<script>

import { DialogComponent } from '@syncfusion/ej2-vue-popups';

export default {
    name: "App",
    components: {
        "ejs-dialog": DialogComponent
    },
    data: function () {
        return {
            target: '#target',
            width: '335px',
            header: 'Dialog',
            content: '<button class="e-control e-btn" id="targetButton" role="button" >Prevent Dialog Scroll</button>',
        }
    },
    mounted: function () {
        document.getElementById('targetButton').onclick = () => {
            this.$refs.scrollDialog.ej2Instances.cssClass = 'e-fixed';
        }
    },
    methods: {
      
        dlgClose: function () {
            document.getElementById('modalbtn').style.display = '';
        },
        dlgOpen: function () {
            document.getElementById('modalbtn').style.display = 'none';
        }
    }
}
</script>
<style>
@import "../node_modules/@syncfusion/ej2-vue-popups/styles/material.css";

#app {
    color: #008cff;
    height: 40px;
    left: 45%;
    position: absolute;
    top: 45%;
    width: 30%;
}

html,
body,
.control-section {
    height: 120%;
    min-height: 200px;
}

body {
    overflow-y: scroll;
}

#loader {
    color: #008cff;
    height: 40px;
    left: 45%;
    position: absolute;
    top: 45%;
    width: 30%;
}

.e-fixed {
    position: fixed;
}
</style>

Center the dialog on page scroll in React Dialog

10 Aug 20265 minutes to read

By default, the Dialog scrolls along with the page or container. To keep the Dialog fixed in the center of the viewport while the page scrolls, apply the e-fixed class to the Dialog element. This prevents the Dialog from moving when the user scrolls the page, maintaining its centered position in the current view.

[Class-component]

import { DialogComponent } from '@syncfusion/ej2-react-popups';
import * as React from "react";
class App extends React.Component {
    dialogInstance;
    handleClick = () => {
        this.dialogInstance.cssClass = 'e-fixed';
    };
    render() {
        return (<div className="App" id='dialog-target'>
    <DialogComponent header='Dialog' width='250px' ref={dialog => this.dialogInstance = dialog} target='#dialog-target' closeOnEscape={false}>
      <button className="e-control e-btn" id="targetButton" role="button" onClick={this.handleClick = this.handleClick}>Prevent Dialog Scroll</button>
    </DialogComponent>
    </div>);
    }
}
export default App;
import { DialogComponent } from '@syncfusion/ej2-react-popups';
import * as React from "react";

class App extends React.Component<{}, {}> {
  public dialogInstance: DialogComponent;
  public handleClick = () => {
      this.dialogInstance.cssClass = 'e-fixed';
  }

  public render() {
    return (
    <div className="App" id='dialog-target'>
    <DialogComponent header='Dialog' width='250px' ref={dialog => this.dialogInstance = dialog!}
    target='#dialog-target' closeOnEscape={false}>
      <button className="e-control e-btn" id="targetButton" role="button" onClick={this.handleClick = this.handleClick}>Prevent Dialog Scroll</button>
    </DialogComponent>
    </div>
    );
  }
}
export default App;

[Functional-component]

import { DialogComponent } from '@syncfusion/ej2-react-popups';
import * as React from "react";
function App() {
    let dialogInstance;
    function handleClick() {
        dialogInstance.cssClass = 'e-fixed';
    }
    return (<div className="App" id='dialog-target'>
        <DialogComponent header='Dialog' width='250px' ref={dialog => dialogInstance = dialog} target='#dialog-target' closeOnEscape={false}>
        <button className="e-control e-btn" id="targetButton" role="button" onClick={handleClick}>Prevent Dialog Scroll</button>
        </DialogComponent>
      </div>);
}
export default App;
import { DialogComponent } from '@syncfusion/ej2-react-popups';
import * as React from "react";

function App() {
    let dialogInstance: DialogComponent;
    function handleClick (){
        dialogInstance.cssClass = 'e-fixed';
    }
  
    return (
      <div className="App" id='dialog-target'>
        <DialogComponent header='Dialog' width='250px' ref={dialog => dialogInstance = dialog!}
        target='#dialog-target' closeOnEscape={false}>
        <button className="e-control e-btn" id="targetButton" role="button" onClick={handleClick}>Prevent Dialog Scroll</button>
        </DialogComponent>
      </div>
    );
}
export default App;